# Contribution Guidelines

## Table of Contents

1. [Introduction](#introduction)
2. [Contributing to Official Plugins](#contributing-to-official-plugins)
3. [Creating Your Own Plugins](#creating-your-own-plugins)
4. [Contributing to Core](#contributing-to-core)

---

## Introduction

Thank you for your interest in contributing! This document outlines how you can contribute to the official plugins and also encourages you to write your own plugins. Please read this guide carefully to understand how you can collaborate with us.

---

## Contributing to Official Plugins

### License

The official plugins for this project are licensed under AGPL. Any contributions you make will also fall under the AGPL license.

### How to Contribute

1. Fork the repository containing the plugin.
2. Clone your fork.
3. Make your changes.
4. Commit and push your changes.
5. Open a pull request.

### Guidelines

- Ensure your code adheres to the existing style.
- Include documentation and unit tests (where applicable).

---

## Creating Your Own Plugins

We encourage developers to write their own plugins. Please refer to the "Getting Started" documentation to learn how to create a plugin for the app.

### Guidelines

- Your plugin's license must be compatible with the core application's license.
- We encourage you to make your plugin open-source, although it's not mandatory.

---

## Contributing to Core


### License

The core is currently licensed under the [Source First License 1.1](./LICENSE.md). All contributors have to sign FUTO Individual Contributor License Agreement before contributions can be accepted. You can read more about it at [https://cla.futo.org/](https://cla.futo.org/).

### How to Contribute

1. Fork the core repository.
2. Clone your fork.
3. Make your changes.
4. Commit and push your changes.
5. Open a pull request.

### Guidelines

- Ensure your code adheres to the existing style.
- Include documentation and unit tests (where applicable).

---

Thank you for reading the contribution guidelines. Happy contributing!


