# Casting in Grayjay App

## Introduction

The Grayjay app supports multiple protocols to cast your favorite content onto a bigger screen. These protocols include FCast, Chromecast, and AirPlay. The list is prioritized in the order of preference for the following reasons:

1. **FCast**: Open protocol, direct streaming support, no need for proxying through mobile devices. Click [here](https://fcast.org/) for more details and where to download.
2. **Chromecast**: Requires proxying but supports DASH streaming.
3. **AirPlay**: Does not support DASH and hence limited in supporting content sources.

The "FCast Receiver" app is available on Google Play store for both Android and Android TV.

## How to Use Casting in Grayjay App

### Finding the Casting Icon

1. Open the Grayjay app on your mobile device.
2. Click on the casting icon located in the top-right corner of the screen.

### Auto Discovery (mDNS)

- Once the casting icon is clicked, auto discovery of nearby devices will start. Note that this uses mDNS and could be slow.

### Manual Device Addition

- Alternatively, you can manually add your device by clicking on the "Add" button, which will appear once you click the casting icon.

### Playback Controls

- Once connected, you can use the Grayjay app to control the playback, including pause, play, seek, and volume adjustments.

## Why Choose FCast Over Others?

1. **Open Source**: The protocol is open source, offering greater freedom and potential for customization.
2. **Direct Streaming**: Unlike Chromecast, which proxies media through the mobile device, FCast supports direct streaming to the receiver.
3. **Multi-Platform**: The FCast Receiver app is available for both Android and Android TV.

By utilizing the built-in casting options, you can enjoy a seamless and versatile streaming experience in Grayjay.

