# Guide to Linking Profiles with Harbor on Polycentric

## Introduction

Polycentric provides a decentralized social media experience, focused on self-sovereign identity and censorship-resistance. Harbor enables you to effortlessly unify your presence across multiple platforms. This guide explains how creators can link their profiles using the Harbor app and what users can expect to see.

For more details:
- Click [here](https://harbor.social/) for more details about the Harbor app.
- Click [here](https://docs.polycentric.io/) for more details about the Polycentric protocol.

---

## For Creators: How to Link Your Profiles

### Step 1: Create a Harbor Identity

1. Download and install the Harbor app.
2. Create a new identity within Harbor.

### Step 2: Create a claim

1. In Harbor, create a claim for a specific channel.

### Step 3: Get the claim verified

1. Follow the instructions to obtain a vouch for the claim.
2. Once it is vouched for by a trusted authority, your profiles will be linked.

### Benefits for Creators

- Unified feed across all platforms.
- Increased visibility and credibility through vouches.
- Privacy protection; remain anonymous if you choose.

---

## For Users: What to Expect

### Unified Feeds

When you're subscribed to a creator's channel that's linked via Harbor, you'll see a unified feed from all their linked platforms.

### Enhanced Privacy

Creators can choose to be anonymous, safeguarding their identities while still sharing valuable content.

---

Thank you for using Polycentric and Harbor to create a more unified and secure online experience.


