# Using Polycentric for Comments and Ratings

## Why Polycentric?

Social media platforms often wield significant control over user data and content. This centralized control creates various issues such as data privacy concerns, content manipulation, and censorship. Polycentric offers an alternative by employing a distributed network, where you, the user, have more sovereignty over your data and interactions. 

### Key Benefits

- **Choose Your Server**: In Polycentric, you can select the server you wish to interact through. This creates healthy competition among servers and provides options for users dissatisfied with content moderation or server policies.
  
- **Ownership of Likes/Dislikes**: As a content creator, the likes and dislikes on your posts are genuinely yours. Unlike centralized platforms, there's no leverage held over you by the hosting platform concerning your ratings.
  
- **Censorship-Resistance**: The distributed architecture makes it challenging to censor content across the entire network, giving voice to marginalized and underrepresented perspectives.

## How to Use Polycentric for Comments and Ratings

### Step 1: Create Your Self-Sovereign Identity

1. Download the [Grayjay](https://grayjay.app) application.
2. Follow the wizard to create your identity secured by public-key cryptography by clicking the "Manage Polycentric Identity" button in the settings page.

### Step 2: Choose Your Server (still a work in progress)

1. Browse the list of available servers and select one based on your preferences for content moderation and community engagement.
2. Connect to the server.

### Step 3: Link Your Content Channels

If you're a creator, link your various content channels using the Harbor app. This provides a unified feed for your subscribers across platforms. Click [here](./linking.md) for more details. 

### Step 4: Engage with Content

You're now ready to comment, like, or dislike content securely and sovereignly. All the likes and dislikes are directly linked to your self-sovereign identity, ensuring true ownership.

### Step 5: Offline Capabilities

Polycentric allows for offline browsing and interactions. Any offline activity will sync upon re-establishing an internet connection.

By leveraging Polycentric, you empower yourself with more control, better privacy, and a truly decentralized social media experience.

